//+------------------------------------------------------------------+
//|                                                  MTF Candles.mq4 |
//|                                       2007, Christof Risch (iya) |
//| Shows candles from another (usually higher) timeframe.				|
//+------------------------------------------------------------------+
#property link "http://www.forexfactory.com/"
#property indicator_chart_window
#property indicator_buffers 8

//---- Candlesticks
#property indicator_color1   C'97,112,126'  //RoyalBlue
#property indicator_color2   C'97,112,126'  //Crimson
#property indicator_color3   C'51,153,97'   //RoyalBlue
#property indicator_color4   C'181,82,214'  //Crimson
#property indicator_width1   1
#property indicator_width2   1
#property indicator_width3   2
#property indicator_width4   2

//---- Heiken Ashi
#property indicator_color5   C'97,112,126'  //darker shade of SlateGray
#property indicator_color6   C'97,112,126'
#property indicator_color7   C'181,82,214'  //darker shade of MediumOrchid
#property indicator_color8   C'51,153,97'   //darker shade of MediumSeaGreen
#property indicator_width5   1
#property indicator_width6   1
#property indicator_width7   2
#property indicator_width8   2
#property indicator_style5   STYLE_SOLID
#property indicator_style6   STYLE_SOLID
#property indicator_style7   STYLE_SOLID
#property indicator_style8   STYLE_SOLID

//---- input parameters
extern bool regular =true;

//---- buffers
double Bar1[],	 Candle1[],
		 Bar2[],	 Candle2[];
int    ExtCountedBars=0;	
double ExtMapBuffer1[];
double ExtMapBuffer2[];
double ExtMapBuffer3[];
double ExtMapBuffer4[];	 

//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
{
//---- indicators
	IndicatorShortName("Candlesticks vs Heiken Ashi");
	
	//---- Candlesticks
	SetIndexBuffer(0,Bar1);
	SetIndexBuffer(1,Bar2);				
	SetIndexBuffer(2,Candle1);
	SetIndexBuffer(3,Candle2);
	SetIndexStyle(0,DRAW_HISTOGRAM);
	SetIndexStyle(1,DRAW_HISTOGRAM);
	SetIndexStyle(2,DRAW_HISTOGRAM);
	SetIndexStyle(3,DRAW_HISTOGRAM);
	
	//---- Heiken Ashi
	SetIndexStyle(4,DRAW_HISTOGRAM); 
   SetIndexBuffer(4, ExtMapBuffer1);
   SetIndexStyle(5,DRAW_HISTOGRAM); 
   SetIndexBuffer(5, ExtMapBuffer2);
   SetIndexStyle(6,DRAW_HISTOGRAM);
   SetIndexBuffer(6, ExtMapBuffer3);
   SetIndexStyle(7,DRAW_HISTOGRAM); 
   SetIndexBuffer(7, ExtMapBuffer4);
		
	return(0);
}

//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start()
{
 if (regular==true)
 {
	for(int i = Bars-1-IndicatorCounted(); i >= 0; i--)
	{
		int shift1 = iBarShift(NULL,0,Time[i]),
			 time1  = iTime    (NULL,0,shift1),
			 shift2 = iBarShift(NULL,0,time1);

		double	high		= iHigh(NULL,0,shift1),
					low		= iLow(NULL,0,shift1),
					open		= iOpen(NULL,0,shift1),
					close		= iClose(NULL,0,shift1),
			 		bodyHigh	= MathMax(open,close),
					bodyLow	= MathMin(open,close);

		if(open<close)
		   {
			Bar1[shift2] = high;		Candle1[shift2] = bodyHigh;
			Bar2[shift2] = low;		Candle2[shift2] = bodyLow;
		   }
		else if(open>close)
		   {
			Bar1[shift2] = low;		Candle1[shift2] = bodyLow;
			Bar2[shift2] = high;		Candle2[shift2] = bodyHigh;
		   }
		else //(open==close)
	   	{	
			Bar1[shift2] = low;		Candle1[shift2] = close;
			Bar2[shift2] = high;		Candle2[shift2] = open+0.000001;
   		}   		   
	}
}

else if (regular ==false)
{
double haOpen, haHigh, haLow, haClose;
   if(Bars<=10) return(0);
   ExtCountedBars=IndicatorCounted();
   //---- check for possible errors
   if (ExtCountedBars<0) return(-1);
   //---- last counted bar will be recounted
   if (ExtCountedBars>0) ExtCountedBars--;
   int pos=Bars-ExtCountedBars-1;
   while(pos>=0)
           {
            haOpen=(ExtMapBuffer3[pos+1]+ExtMapBuffer4[pos+1])/2;
            haClose=(Open[pos]+High[pos]+Low[pos]+Close[pos])/4;
            haHigh=MathMax(High[pos], MathMax(haOpen, haClose));
            haLow=MathMin(Low[pos], MathMin(haOpen, haClose));
            if (haOpen<haClose) 
              {
               ExtMapBuffer1[pos]=haLow;
               ExtMapBuffer2[pos]=haHigh;
              } 
            else
              {
               ExtMapBuffer1[pos]=haHigh;
               ExtMapBuffer2[pos]=haLow;
              } 
            ExtMapBuffer3[pos]=haOpen;
            ExtMapBuffer4[pos]=haClose;
 	         pos--;
           }
}

	return(0);
}
//+------------------------------------------------------------------+

