//------------------------------------------------------------------
#property copyright "www.forex-tsd.com"
#property link      "www.forex-tsd.com"
//------------------------------------------------------------------
#property indicator_chart_window
#property indicator_buffers 4
#property indicator_color1  PaleVioletRed
#property indicator_color2  LimeGreen
#property indicator_color3  PaleVioletRed
#property indicator_color4  LimeGreen
#property indicator_width1  2
#property indicator_width2  2

//
//
//
//
//

extern int PriceSmoothing  = 5;
extern int ResultSmoothing = 12;

//
//
//
//
//

double haOpen[];
double haClose[];
double haHigh[];
double haLow[];

//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//
//

int init()
{
   SetIndexBuffer(0,haOpen);  SetIndexStyle(0,DRAW_HISTOGRAM);
   SetIndexBuffer(1,haClose); SetIndexStyle(1,DRAW_HISTOGRAM);
   SetIndexBuffer(2,haLow);   SetIndexStyle(2,DRAW_HISTOGRAM);
   SetIndexBuffer(3,haHigh);  SetIndexStyle(3,DRAW_HISTOGRAM);
   IndicatorShortName("Heiken ashi smoothed ("+PriceSmoothing+","+ResultSmoothing+")");
}
int deinit() { return(0); }

//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//
//

double work[][4];
#define _haOpen  0
#define _haClose 1
#define _haLow   2
#define _haHigh  3

int start()
{
   int i,r,counted_bars=IndicatorCounted();
      if(counted_bars<0) return(-1);
      if(counted_bars>0) counted_bars--;
           int limit=MathMin(Bars-counted_bars,Bars-1);
           if (ArrayRange(work,0)!=Bars) ArrayResize(work,Bars);

   //
   //
   //
   //
   //

   for(i=limit, r=Bars-i-1; i>=0; i--,r++)
   {
      double maOpen  = iDema(iMA(NULL,0,1,0,0,PRICE_OPEN ,i),PriceSmoothing,i,0);
      double maClose = iDema(iMA(NULL,0,1,0,0,PRICE_CLOSE,i),PriceSmoothing,i,1);
      double maLow   = iDema(iMA(NULL,0,1,0,0,PRICE_LOW  ,i),PriceSmoothing,i,2);
      double maHigh  = iDema(iMA(NULL,0,1,0,0,PRICE_HIGH ,i),PriceSmoothing,i,3);

         //
         //
         //
         //
         //
         
         work[r][_haLow]   = work[r-1][_haLow];
         work[r][_haHigh]  = work[r-1][_haHigh];
         work[r][_haOpen]  = (work[r-1][_haOpen]+work[r-1][_haClose])/2.0;
         work[r][_haClose] = (maOpen+maHigh+maLow+maClose)/4.0;
         double hatHigh    = MathMax(maHigh,MathMax(work[r][_haOpen],work[r][_haClose]));
         double hatLow     = MathMin(maLow ,MathMin(work[r][_haOpen],work[r][_haClose]));
               if (work[r][_haOpen]<work[r][_haClose]) { work[r][_haLow] = hatLow;  work[r][_haHigh] = hatHigh; } 
               if (work[r][_haOpen]>work[r][_haClose]) { work[r][_haLow] = hatHigh; work[r][_haHigh] = hatLow;  } 

         //
         //
         //
         //
         //
      
      haOpen[i]  = iDema(work[r][_haOpen] ,ResultSmoothing,i,4);
      haClose[i] = iDema(work[r][_haClose],ResultSmoothing,i,5);
      haHigh[i]  = iDema(work[r][_haHigh] ,ResultSmoothing,i,6);
      haLow[i]   = iDema(work[r][_haLow]  ,ResultSmoothing,i,7);
   }
   return(0);
}




//------------------------------------------------------------------
//                                                                  
//------------------------------------------------------------------
//
//
//
//
//

double workDema[][16];
#define _ema1 0
#define _ema2 1

double iDema(double price, double period, int r, int instanceNo=0)
{
   if (ArrayRange(workDema,0)!= Bars) ArrayResize(workDema,Bars); instanceNo*=2; r = Bars-r-1;

   //
   //
   //
   //
   //
      
   double alpha = 2.0 / (1.0+period);
          workDema[r][_ema1+instanceNo] = workDema[r-1][_ema1+instanceNo]+alpha*(price                        -workDema[r-1][_ema1+instanceNo]);
          workDema[r][_ema2+instanceNo] = workDema[r-1][_ema2+instanceNo]+alpha*(workDema[r][_ema1+instanceNo]-workDema[r-1][_ema2+instanceNo]);
   return(workDema[r][_ema1+instanceNo]*2.0-workDema[r][_ema2+instanceNo]);
}