//+------------------------------------------------------------------+
//|                                               VIP_HeikenAshi.mq4 |
//|                                       Copyright  2010, KingLion |
//|                                     http://www.metastock.org.ua/ |
//+------------------------------------------------------------------+
#property copyright "Copyright  2010, KingLion"
#property link      "http://www.metastock.org.ua/"

#property indicator_separate_window
#property indicator_buffers 2
#property indicator_color1  Red
#property indicator_color2  DodgerBlue
#property indicator_width1  2
#property indicator_width2  2
#property indicator_minimum 0
#property indicator_maximum 1


//--- input parameters
extern string Custom_Indicator = "VIP Heiken Ashi";
extern string Copyright = "Copyright  2010, KingLion";
extern string Web_Address = "www.metastock.org.ua";
//--- buffers
double HA_0[];
double HA_1[];
double HA_Open[];
double HA_Close[];
int counted_bars = 0;
int init()
  {
      IndicatorBuffers(4);
      SetIndexStyle(0, DRAW_HISTOGRAM);
      SetIndexBuffer(0, HA_0);
      SetIndexLabel(0, "HA_0");
      SetIndexStyle(1, DRAW_HISTOGRAM);
      SetIndexBuffer(1, HA_1);
      SetIndexLabel(1, "HA_1");
      SetIndexBuffer(2, HA_Open);
      SetIndexLabel(2, "HA_Open");
      SetIndexBuffer(3, HA_Close);
      SetIndexLabel(3, "HA_Close");
      SetIndexDrawBegin(0, 10);
      SetIndexDrawBegin(1, 10);
   return(0);
  }
int deinit()
  {
   return(0);
  }
int start()
  {
   double MinLow;
   double MaxHigh;
   double OHLC8;
   double OHLC4;
   if (Bars <= 10) return (0);
   counted_bars = IndicatorCounted();
   if (counted_bars < 0) return (-1);
   if (counted_bars > 0) counted_bars--;
   for (int i = Bars - counted_bars - 1; i >= 0; i--) {
      OHLC4 = NormalizeDouble((Open[i] + High[i] + Low[i] + Close[i]) / 4.0, Digits);
      OHLC4 = (OHLC4 + Close[i]) / 2.0;
      OHLC8 = NormalizeDouble((HA_Open[i + 1] + (HA_Close[i + 1])) / 2.0, Digits);
      MaxHigh = MathMax(High[i], MathMax(OHLC8, OHLC4));
      MinLow = MathMin(Low[i], MathMin(OHLC8, OHLC4));
      if (OHLC8 < OHLC4) {
         HA_0[i] = EMPTY_VALUE;
         HA_1[i] = 1;
      } else {
         HA_0[i] = 1;
         HA_1[i] = EMPTY_VALUE;
      }
      HA_Open[i] = OHLC8;
      HA_Close[i] = OHLC4;
   }
   return(0);
  }